/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.niederschrift.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="NIEDERSCHRIFT.UK",
     query="SELECT o FROM Niederschrift o WHERE "

                         + "o"
                +".niederschriftArt"
              +" = ?1"

             +" AND "         + "o"
                +".wahldurchfuehrungsgebiet"
                +".nummer"
              +" = ?2"

             +" AND "         + "o"
                +".wahldurchfuehrungsgebiet"
                +".gebietsart"
                +".name"
              +" = ?3"

             +" AND "         + "o"
                +".wahldurchfuehrungsgebiet"
                +".gebietsart"
                +".mandant"
                +".nummer"
              +" = ?4"

             +" AND "         + "o"
                +".wahldurchfuehrungsgebiet"
                +".wahl"
                +".wahlart"
                +".name"
              +" = ?5"

             +" AND "         + "o"
                +".wahldurchfuehrungsgebiet"
                +".wahl"
                +".wahlart"
                +".mandant"
                +".nummer"
              +" = ?6"

             +" AND "         + "o"
                +".wahldurchfuehrungsgebiet"
                +".wahl"
                +".wahltermin"
                +".nummer"
              +" = ?7"

             +" AND "         + "o"
                +".wahldurchfuehrungsgebiet"
                +".wahl"
                +".wahltermin"
                +".wahldatum"
              +" = ?8"

             +" AND "         + "o"
                +".wahldurchfuehrungsgebiet"
                +".wahl"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?9"

             +" AND "         + "o"
                +".wahldurchfuehrungsgebiet"
                +".wahltermin"
                +".nummer"
              +" = ?10"

             +" AND "         + "o"
                +".wahldurchfuehrungsgebiet"
                +".wahltermin"
                +".wahldatum"
              +" = ?11"

             +" AND "         + "o"
                +".wahldurchfuehrungsgebiet"
                +".wahltermin"
                +".mandant"
                +".nummer"
              +" = ?12"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="NIEDERSCHRIFT.KuerzelSchnelleingabe",
     query="SELECT obj FROM Niederschrift obj WHERE obj.wahldurchfuehrungsgebiet.wahl.kennzeichen IS NOT NULL AND UPPER(obj.wahldurchfuehrungsgebiet.wahl.kennzeichen) = UPPER(?1) AND obj.wahldurchfuehrungsgebiet.wahl.wahltermin.wahldatum = ?2 AND obj.wahldurchfuehrungsgebiet.nummer IS NOT NULL AND UPPER(obj.wahldurchfuehrungsgebiet.nummer) = UPPER(?3) AND obj.niederschriftArt = ?4",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="NIEDERSCHRIFT.Wahl",
     query="SELECT n FROM Niederschrift n WHERE n.wahldurchfuehrungsgebiet.wahl = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
         ,   @javax.persistence.NamedQuery(
     name="NIEDERSCHRIFT.Wahldurchfuehrungsgebiet",
     query="SELECT n FROM Niederschrift n WHERE n.wahldurchfuehrungsgebiet = ?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "NIEDERSCHRIFT")
// @javax.persistence.IdClass(NiederschriftPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class Niederschrift
extends AbstractNiederschrift
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public Niederschrift() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public Niederschrift(Niederschrift original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "niederschrift_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "Niederschrift")
    @javax.persistence.TableGenerator(name = "Niederschrift", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "Niederschrift", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient NiederschriftPK pkCache;

  @Override
  public NiederschriftPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new NiederschriftPK(getId());
    }

    return pkCache;
  }

  public static <E extends Niederschrift> java.util.Map<NiederschriftPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<NiederschriftPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends Niederschrift> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedNiederschriftArt = false;
  
      hasChangedWahldurchfuehrungsgebiet = false;
  

          hasChangedNiederschriftKorrektursByNiederschrift = false;
                hasChangedNiederschriftStatusAenderungsByNiederschrift = false;
      
    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
    @javax.persistence.Enumerated(javax.persistence.EnumType.STRING)
      @javax.persistence.Column(name = "NIEDERSCHRIFT_ART", nullable = NiederschriftConstants.NIEDERSCHRIFT_ART_NULLABLE)
    
  protected de.ivu.elect.business.niederschrift.entity.NiederschriftArt niederschriftArt =  de.ivu.elect.business.niederschrift.entity.NiederschriftArt.NIEDERSCHRIFT;

  @javax.persistence.Transient
  protected boolean hasChangedNiederschriftArt = false;

  public boolean hasChangedNiederschriftArt(){
    return hasChangedNiederschriftArt;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertNiederschriftArt = false;
     @javax.persistence.Transient
     private transient de.ivu.elect.business.niederschrift.entity.NiederschriftArt wertNachLadenNiederschriftArt;
  
  /**
   * 
   *
   * getter for NIEDERSCHRIFT.NIEDERSCHRIFT_ART
   */
    @Override   public  de.ivu.elect.business.niederschrift.entity.NiederschriftArt getNiederschriftArt() {
        return niederschriftArt;
      }

  /**
   * 
   *
   * setter for NIEDERSCHRIFT.NIEDERSCHRIFT_ART
   *
   * @param niederschriftArt
   */
  @Override   public void setNiederschriftArt( de.ivu.elect.business.niederschrift.entity.NiederschriftArt niederschriftArt) {

       resetTkCache();
                  de.ivu.elect.business.niederschrift.entity.NiederschriftArt niederschriftArtInternal = niederschriftArt;
       
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.niederschriftArt
      , niederschriftArtInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedNiederschriftArt |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("niederschriftArt");
      }


             if (!isSeitLadenVeraendertNiederschriftArt) {
          isSeitLadenVeraendertNiederschriftArt = thisAttributChanged;
         if (isSeitLadenVeraendertNiederschriftArt){
           wertNachLadenNiederschriftArt=this.niederschriftArt;
         }
       }
      

       this.niederschriftArt = niederschriftArtInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Wahldurchfuehrungsgebiet
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "WAHLDURCHFUEHRUNGSGEBIET_ID", referencedColumnName="GEBIET_ID"))
  protected de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet wahldurchfuehrungsgebiet;

  /**
   * 
   */
  @Override
  public void setWahldurchfuehrungsgebiet( de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet wahldurchfuehrungsgebiet){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.wahldurchfuehrungsgebiet
    , wahldurchfuehrungsgebiet);

    attributeChanged |= thisAttributChanged;

    hasChangedWahldurchfuehrungsgebiet |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("wahldurchfuehrungsgebiet");
    }

    this.wahldurchfuehrungsgebiet = wahldurchfuehrungsgebiet;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.gebietsbaum.entity.Wahldurchfuehrungsgebiet getWahldurchfuehrungsgebiet(){
    return this.wahldurchfuehrungsgebiet;
  }

  @javax.persistence.Transient
  protected boolean hasChangedWahldurchfuehrungsgebiet = false;

  public boolean hasChangedWahldurchfuehrungsgebiet(){
    return hasChangedWahldurchfuehrungsgebiet;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehung 1:N (bidirektional) zu NiederschriftKorrektursByNiederschrift
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur.class, mappedBy="niederschrift", fetch=javax.persistence.FetchType.LAZY )
// deaktiviert, gibt Probleme beim Löschen  @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur> niederschriftKorrektursByNiederschrift;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  
  @Override
  public java.util.Set<de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur> getNiederschriftKorrektursByNiederschrift(){
    if (niederschriftKorrektursByNiederschrift == null){
      return  java.util.Collections.<de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur>unmodifiableSet(this.niederschriftKorrektursByNiederschrift);
  }

  @javax.persistence.Transient
  private boolean hasChangedNiederschriftKorrektursByNiederschrift = false;

  public boolean hasChangedNiederschriftKorrektursByNiederschrift() {
    return hasChangedNiederschriftKorrektursByNiederschrift;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur
   */
  @Override
  public void addNiederschriftKorrekturByNiederschrift(de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur niederschriftKorrekturByNiederschrift){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (niederschriftKorrekturByNiederschrift != null){
          if (this.niederschriftKorrektursByNiederschrift == null) {
            this.niederschriftKorrektursByNiederschrift = new java.util.HashSet<>();
          }

          boolean isChanged = this.niederschriftKorrektursByNiederschrift.add(niederschriftKorrekturByNiederschrift);

          if(!hasChangedNiederschriftKorrektursByNiederschrift) {
            hasChangedNiederschriftKorrektursByNiederschrift =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          niederschriftKorrekturByNiederschrift.setNiederschrift(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur
   */
  @Override
  public void removeNiederschriftKorrekturByNiederschrift(de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur niederschriftKorrekturByNiederschrift){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (niederschriftKorrekturByNiederschrift != null){
          if (this.niederschriftKorrektursByNiederschrift != null) {
            boolean isChanged = this.niederschriftKorrektursByNiederschrift.remove(niederschriftKorrekturByNiederschrift);

            if(!hasChangedNiederschriftKorrektursByNiederschrift) {
              hasChangedNiederschriftKorrektursByNiederschrift =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          niederschriftKorrekturByNiederschrift.setNiederschrift(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur
  */
   @Override
   public void removeAllNiederschriftKorrekturByNiederschrifts(){
     java.util.Set<de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur> toRemove = new java.util.HashSet<>(getNiederschriftKorrektursByNiederschrift());

     for (   de.ivu.elect.business.niederschrift.entity.NiederschriftKorrektur entity:toRemove){
       removeNiederschriftKorrekturByNiederschrift(entity);
     }
   }

  /**
   * Beziehung 1:N (bidirektional) zu NiederschriftStatusAenderungsByNiederschrift
   *
   */
  @javax.persistence.OneToMany(targetEntity=de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung.class, mappedBy="niederschrift", fetch=javax.persistence.FetchType.LAZY )
// deaktiviert, gibt Probleme beim Löschen  @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung> niederschriftStatusAenderungsByNiederschrift;


  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  
  @Override
  public java.util.Set<de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung> getNiederschriftStatusAenderungsByNiederschrift(){
    if (niederschriftStatusAenderungsByNiederschrift == null){
      return  java.util.Collections.<de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung>emptySet());
    }

    return java.util.Collections.<de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung>unmodifiableSet(this.niederschriftStatusAenderungsByNiederschrift);
  }

  @javax.persistence.Transient
  private boolean hasChangedNiederschriftStatusAenderungsByNiederschrift = false;

  public boolean hasChangedNiederschriftStatusAenderungsByNiederschrift() {
    return hasChangedNiederschriftStatusAenderungsByNiederschrift;
  }

  /**
   * Hinzufuegen von de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung
   */
  @Override
  public void addNiederschriftStatusAenderungByNiederschrift(de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung niederschriftStatusAenderungByNiederschrift){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (niederschriftStatusAenderungByNiederschrift != null){
          if (this.niederschriftStatusAenderungsByNiederschrift == null) {
            this.niederschriftStatusAenderungsByNiederschrift = new java.util.HashSet<>();
          }

          boolean isChanged = this.niederschriftStatusAenderungsByNiederschrift.add(niederschriftStatusAenderungByNiederschrift);

          if(!hasChangedNiederschriftStatusAenderungsByNiederschrift) {
            hasChangedNiederschriftStatusAenderungsByNiederschrift =  isChanged;
          }

          // andere Seite der Beziehung aktualisieren
          niederschriftStatusAenderungByNiederschrift.setNiederschrift(this);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung
   */
  @Override
  public void removeNiederschriftStatusAenderungByNiederschrift(de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung niederschriftStatusAenderungByNiederschrift){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (niederschriftStatusAenderungByNiederschrift != null){
          if (this.niederschriftStatusAenderungsByNiederschrift != null) {
            boolean isChanged = this.niederschriftStatusAenderungsByNiederschrift.remove(niederschriftStatusAenderungByNiederschrift);

            if(!hasChangedNiederschriftStatusAenderungsByNiederschrift) {
              hasChangedNiederschriftStatusAenderungsByNiederschrift =  isChanged;
            }
          }

          // andere Seite der Beziehung aktualisieren
          niederschriftStatusAenderungByNiederschrift.setNiederschrift(null);
        }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung
  */
   @Override
   public void removeAllNiederschriftStatusAenderungByNiederschrifts(){
     java.util.Set<de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung> toRemove = new java.util.HashSet<>(getNiederschriftStatusAenderungsByNiederschrift());

     for (   de.ivu.elect.business.niederschrift.entity.NiederschriftStatusAenderung entity:toRemove){
       removeNiederschriftStatusAenderungByNiederschrift(entity);
     }
   }

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("Niederschrift:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(Niederschrift other){
                             other.niederschriftArt = this.niederschriftArt;
           
  other.setWahldurchfuehrungsgebiet(this.getWahldurchfuehrungsgebiet());
    if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(Niederschrift.class)){
        copyEntityAttributesUsingSetter((Niederschrift) other.castTo(Niederschrift.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von Niederschrift: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(Niederschrift other){
               other.setNiederschriftArt(this.niederschriftArt);
           if (this.transientContext != null && !this.transientContext.isEmpty()) {
      other.getTransientContext().putAll(this.transientContext);
    }
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(Niederschrift other){
                       if (hasChangedNiederschriftArt) {
        other.setNiederschriftArt(this.niederschriftArt);
      }
             }





    @javax.persistence.Transient
    private transient NiederschriftTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public NiederschriftTK getNiederschriftTK(){
    if (tkCache==null) {
    tkCache = new NiederschriftTK(

getNiederschriftArt()
,   (getWahldurchfuehrungsgebiet() == null) ? null : getWahldurchfuehrungsgebiet().getWahldurchfuehrungsgebietTK()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getNiederschriftTK();
    }

  @Override
  public NiederschriftUK getUk(){
    return getNiederschriftUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return Niederschrift.class;
  }

public NiederschriftUK getNiederschriftUK(){

   return  new NiederschriftUK(

getNiederschriftArt()
,     getWahldurchfuehrungsgebiet()==null?null:getWahldurchfuehrungsgebiet().getWahldurchfuehrungsgebietUK()


  );
}

  @javax.persistence.Transient
  private transient NiederschriftProperties properties;

  public NiederschriftProperties getProperties(){
    if (properties == null) {
      properties = new NiederschriftProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public NiederschriftProperties getNiederschriftProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return NiederschriftConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(NiederschriftConstants.MESSAGE_KEY_NIEDERSCHRIFT_ART_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(NiederschriftConstants.MESSAGE_KEY_NIEDERSCHRIFT_ART_EINZAHL);

        niederschriftArt =
     (de.ivu.elect.business.niederschrift.entity.NiederschriftArt) vorher.getAttributTyp().getValueAsEnum(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertNiederschriftArt) {
      result.put(NiederschriftConstants.MESSAGE_KEY_NIEDERSCHRIFT_ART_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.ENUM
                , wertNachLadenNiederschriftArt , niederschriftArt));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertNiederschriftArt = false;
      wertNachLadenNiederschriftArt = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "NIEDERSCHRIFT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "Niederschrift";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(niederschriftArt, this, NiederschriftConstants.MESSAGE_KEY_NIEDERSCHRIFT_ART_EINZAHL, validationResult);
                                                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        protected transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
